import java.lang.instrument.*;
import java.lang.reflect.ReflectPermission;
import java.security.ProtectionDomain;
import java.security.*;

class SecurityIsGood extends RuntimeException {}

public class Agent {
    public static void premain(final String agentArgs, final Instrumentation inst) {
        Thread thread = Thread.currentThread();
        inst.addTransformer(new ClassFileTransformer() {
            @Override
            public byte[] transform(ClassLoader loader, String className, Class<?> classBeingRedefined,
                    ProtectionDomain protectionDomain, byte[] classfileBuffer) throws IllegalClassFormatException {
                if (className.equals("Secret")) {
                    thread.getUncaughtExceptionHandler().uncaughtException(thread, new SecurityIsGood());
                }
                return classfileBuffer;
            }
        });
        thread.setUncaughtExceptionHandler(new Thread.UncaughtExceptionHandler() {
            @Override
            public void uncaughtException(Thread t, Throwable e) {
                if (e instanceof SecurityIsGood) {
                    System.exit(7);
                }
                e.printStackTrace();
                System.exit(1);
            }
        });
        System.setSecurityManager(new SecurityManager());
    }
}